#ifndef MSP_IO_SERIAL_H_
#define MSP_IO_SERIAL_H_

#include "eventobject.h"
#include "eventreader.h"
#include "handle.h"

namespace Msp {
namespace IO {

class Serial: public EventObject
{
public:
	enum Parity
	{
		NONE,
		EVEN,
		ODD
	};

private:
	Handle handle;
	EventReader reader;

public:
	Serial(const std::string &);
	virtual ~Serial();

private:
	void close();

public:
	virtual void set_block(bool);

	void set_baud_rate(unsigned);
	void set_data_bits(unsigned);
	void set_parity(Parity);
	void set_stop_bits(unsigned);
	void set_parameters(const std::string &);

private:
	virtual unsigned do_write(const char *, unsigned);
	virtual unsigned do_read(char *, unsigned);

public:
	virtual const Handle &get_event_handle() { return reader.get_event(); }
};

} // namespace IO
} // namespace Msp

#endif
